Index: GTP/trunk/App/Demos/Vis/CHC_revisited/Bvh.cpp
===================================================================
--- GTP/trunk/App/Demos/Vis/CHC_revisited/Bvh.cpp	(revision 2752)
+++ GTP/trunk/App/Demos/Vis/CHC_revisited/Bvh.cpp	(revision 2755)
@@ -1273,329 +402,5 @@
 float Bvh::CalcDistance(BvhNode *node) const
 {
-	timeDistance.Entry();
-
-	float distance;
-
-#if USE_TIGHTER_BOUNDS_FOR_ALL
-	float minDist = 1e25f;
-
-	//OUT1("testing " << mNumTestNodes << " nodes");
-	for (int i = 0; i < node->mNumTestNodes; ++ i)
-	{
-		RenderableHierarchyNode *hnode = mTestNodes[node->mTestNodesIdx + i];
-
-		if(hnode->mCache.mLastDistanceTestedFrameId < mFrameId)
-		{
-			hnode->mCache.mDistance = 
-				hnode->GetBox().getMinVisibleDistance(mNearPlane, mNearPlaneD);
-			hnode->mCache.mLastDistanceTestedFrameId = mFrameId;
-		}
-
-		if (hnode->mCache.mDistance < minDist)
-			minDist = hnode->mCache.mDistance;
-	}
-
-	distance = minDist;
-
-#else
-
-	if(node->mCache.mLastDistanceTestedFrameId != mFrameId)
-	{
-		//OUT1("z " << node->mLastDistanceTestedFrameId  << " " << mFrameId);
-		node->mCache.mDistance = node->GetBox().getMinVisibleDistance(mNearPlane, mNearPlaneD);
-		node->mCache.mLastDistanceTestedFrameId = mFrameId;
-	}
-
-	distance = node->mCache.mDistance;
-#endif
-
-	timeDistance.Exit();
-
-	return distance;
-}
-
-
-float Bvh::GetSquareDistance(BvhNode *node) const
-{
-	timeDistance.Entry();
-
-	float distance;
-
-#if USE_TIGHTER_BOUNDS_FOR_ALL
-	const Vector3f nearplane = mCamera->GetRealViewDirection();
-	const float nearplaneD = - nearplane * (mCamera->GetPosition() - Origin3f);
-
-	float minDist = 1e25f;
-	
-	//OUT1("testing " << mNumTestNodes << " nodes");
-	for (int i = 0; i < node->mNumTestNodes; ++ i)
-	{
-		RenderableHierarchyNode *hnode = mTestNodes[node->mTestNodesIdx + i];
-		const float dist = GetMinSquareDistance(hnode->GetBox());
-
-		if (dist < minDist)
-			minDist = dist;
-	}
-
-	distance = minDist;
-#else
-	distance = GetMinSquareDistance(node->GetBox());
-#endif
-
-	timeDistance.Exit();
-
-	return distance;
-}
-
-
-float Bvh::GetMinSquareDistance(const BoundingBox &box) const
-{
-	float minDist = 1e25f;
-
-	const Point3f *pts = (const Point3f *)box.getVertexData();
-	const Point3f pos = mCamera->GetPosition();
-
-	for (int i = 0; i < 8; ++ i)
-	{
-		const float newDist = DistanceSquared(pts[i], pos);
-
-		if (newDist < minDist)
-			minDist = newDist;
-	}
-
-	return minDist;
-}
-
-
-bool Bvh::ExportBinTree(const string &filename)
-{
-	ofstream stream(filename.c_str(), ifstream::binary);
-	
-	if (!stream.is_open()) return false;
-
-	OUT1("exporting bvh");
-
-	std::queue<BvhNode *> tStack;
-	tStack.push(mRoot);
-
-	while(!tStack.empty())
-	{
-		BvhNode *node = tStack.front();
-		tStack.pop();
-		
-		if (node->IsLeaf())
-		{
-			//OUT1("l");
-			ExportBinLeaf(stream, static_cast<BvhLeaf *>(node));
-		}
-		else
-		{
-			//OUT1("i");
-			BvhInterior *interior = static_cast<BvhInterior *>(node);
-
-			ExportBinInterior(stream, interior);
-			
-			tStack.push(interior->mFront);
-			tStack.push(interior->mBack);
-		}
-	}
-
-	OUT1("... finished");
-
-	return true;
-}
-
-
-void Bvh::ExportBinLeaf(ofstream &stream, BvhLeaf *leaf)
-{
-	int type = TYPE_LEAF;
-	int first = leaf->mFirst;
-	int last = leaf->mLast;
-
-	stream.write(reinterpret_cast<char *>(&type), sizeof(int));
-	stream.write(reinterpret_cast<char *>(&first), sizeof(int));
-	stream.write(reinterpret_cast<char *>(&last), sizeof(int));
-}
-
-
-void Bvh::ExportBinInterior(ofstream &stream, BvhInterior *interior)
-{
-	int type = TYPE_INTERIOR;
-	stream.write(reinterpret_cast<char *>(&type), sizeof(int));
-	stream.write(reinterpret_cast<char *>(&interior->mAxis), sizeof(char));
-	stream.write(reinterpret_cast<char *>(&interior->mPosition), sizeof(float));
-}
-
-
-BvhLeaf *Bvh::ImportBinLeaf(ifstream &stream, BvhInterior *parent)
-{
-	BvhLeaf *leaf = new BvhLeaf(parent);
-
-	int first, last;
-
-	stream.read(reinterpret_cast<char *>(&first), sizeof(int));
-	stream.read(reinterpret_cast<char *>(&last), sizeof(int));
-
-	leaf->mFirst = first;
-	leaf->mLast = last;
-
-	return leaf;
-}
-
-
-BvhInterior *Bvh::ImportBinInterior(ifstream &stream, BvhInterior *parent)
-{
-	BvhInterior *interior = new BvhInterior(parent);
-
-	stream.read(reinterpret_cast<char *>(&interior->mAxis), sizeof(char));
-	stream.read(reinterpret_cast<char *>(&interior->mPosition), sizeof(float));
-
-	return interior;
-}
-
-
-BvhNode *Bvh::LoadNextNode(ifstream &stream, BvhInterior *parent)
-{
-	int nodeType;
-	stream.read(reinterpret_cast<char *>(&nodeType), sizeof(int));
-
-	if (nodeType == TYPE_LEAF)
-	{
-		//OUT1("l");
-		return ImportBinLeaf(stream, static_cast<BvhInterior *>(parent));
-	}
-
-	if (nodeType == TYPE_INTERIOR)
-	{
-		//OUT1("i");
-		return ImportBinInterior(stream, static_cast<BvhInterior *>(parent));
-	}
-
-	return NULL;
-}
-
-
-Bvh *Bvh::LoadFromFile(const string &filename, const GeometryVector &geom)
-{
-	// export binary version of mesh
-	queue<BvhNode *> tStack;
-	ifstream stream(filename.c_str(), ifstream::binary);
-
-	if (!stream.is_open()) return NULL;
-
-	OUT1("loading bvh");
-	Bvh *bvh = new Bvh();
-
-	bvh->mGeometrySize = geom.size();
-	bvh->mGeometry = new NodeGeometry*[bvh->mGeometrySize];
-
-	for (size_t i = 0; i < bvh->mGeometrySize; ++ i)
-		bvh->mGeometry[i] = geom[i];
-
-	bvh->mRoot = bvh->LoadNextNode(stream, NULL);
-
-	tStack.push(bvh->mRoot);
-	bvh->mNumNodes = 1;
-
-	while(!tStack.empty())
-	{
-		BvhNode *node = tStack.front();
-		tStack.pop();
-
-		if (!node->IsLeaf())
-		{
-			bvh->mNumNodes += 2;
-
-			BvhInterior *interior = static_cast<BvhInterior *>(node);
-
-            BvhNode *front = bvh->LoadNextNode(stream, interior);
-			BvhNode *back = bvh->LoadNextNode(stream, interior);
-	
-			interior->mFront = front;
-			interior->mBack = back;
-
-			front->mDepth = interior->mDepth + 1;
-			back->mDepth = interior->mDepth + 1;
-
-			tStack.push(front);			
-			tStack.push(back);
-		}
-	}
-
-	OUT1("... finished loading " << bvh->mNumNodes << " nodes, updating boxes");
-
-	//adjust bounding boxes
-	bvh->UpdateBoxes(bvh->mRoot);
-	bvh->UpdateNumLeaves(bvh->mRoot);
-
-	// compute unique ids
-	bvh->ComputeIds();
-	// update the indices of the geometry so we can render interiors as well
-	bvh->UpdateInteriors(bvh->mRoot);
-	// do this once so at least the current node bounding box is tested
-	bvh->RecomputeBounds();
-
-	return bvh;
-}
-
-
-float Bvh::ComputeScreenSpaceProjection(BvhNode *node) const
-{
-#if 0
-	int projection = 0;
-
-	for (int i = 0; i < node->mNumTestNodes; ++ i)
-	{
-		RenderableHierarchyNode *n = mTestNodes[node->mTestNodesIdx + i];
-
-		if(hnode->.mCache.mLastProjectionFrameId < mFrameId)
-		{
-			hnode->mCache.mProjection = 
-				ComputeScreenSpaceProjection(hnode->GetBox());
-			hnode->mCache.mLastProjectionFrameId = mCurrentFrameId;
-		}
-		
-		projection += hnode->mCache.mProjection;
-	}
-
-	return projection;
-
-#else
-
-	if(node->mCache.mLastProjectionFrameId < mFrameId)
-	{
-		node->mCache.mProjection = 
-			ComputeScreenSpaceProjection(node->GetBox());
-		node->mCache.mLastProjectionFrameId = mFrameId;
-	}
-
-	return node->mCache.mProjection;
-#endif
-}
-
-
-float Bvh::ComputeScreenSpaceProjection(const BoundingBox &box) const
-{
-#if 0
-	const float dist = CalcDistance(box);
-#else
-	//const float dist = sqrt(GetMinSquareDistance(box));
-	const float dist = Distance(mCamera->GetPosition(), box.getCenter());
-#endif
-
-	const float scale = dist ? dist * mScale : 1e-6;
-	const float f = 1.0f / scale;
-	const float coverage = f * f * box.getSurface() / 6.0f;
-
-#if 0
-	OUT1("scale: " << scale);
-	OUT1("box: " << box.getSurface());
-	OUT1("aspect: " << aspect);
-	OUT1("fov: " << fov);
-	OUT1("tan: " << tan(fov * mypi / 180.0f));
-	//OUT1("w: " << w << " h: " << h);
-	OUT1("cov: " << coverage << " pix: " << coverage * w * h << " f: " << f);
-#endif
-	return coverage;
+	return node->GetBox().GetMinVisibleDistance(sNearPlane);
 }
 
@@ -1603,107 +408,17 @@
 void Bvh::RenderBoundingBox(BvhNode *node)
 {
-#if 1
 	static BvhNodeContainer dummy(1);
 	dummy[0] = node;
 	RenderBoundingBoxes(dummy);
-#else
-	RenderBoxIndividual(node);
-#endif
-}
-
-
-void Bvh::RenderBoundingBoxImmediate(const BoundingBox &box, const bool restartStrip)
-{
-	const Point3f *pU = box.getUpperPtr();
-	const Point3f *pL = box.getLowerPtr();
-
-	///////////
-	//-- render AABB as triangle strips
-
-	glVertex3f(pL->x, pL->y, pU->z);
-	glVertex3f(pU->x, pL->y, pU->z);
-	glVertex3f(pL->x, pU->y, pU->z);
-	glVertex3f(pU->x, pU->y, pU->z);
-	glVertex3f(pL->x, pU->y, pL->z); 
-	glVertex3f(pU->x, pU->y, pL->z);
-	glVertex3f(pL->x, pL->y, pL->z); 
-	glVertex3f(pU->x, pL->y, pL->z);
-
-	glPrimitiveRestartNV();
-
-	//-- render second half of AABB
-	glVertex3f(pL->x, pU->y, pU->z); 
-	glVertex3f(pL->x, pU->y, pL->z);
-	glVertex3f(pL->x, pL->y, pU->z);
-	glVertex3f(pL->x, pL->y, pL->z);
-	glVertex3f(pU->x, pL->y, pU->z); 
-	glVertex3f(pU->x, pL->y, pL->z);
-	glVertex3f(pU->x, pU->y, pU->z); 
-	glVertex3f(pU->x, pU->y, pL->z);
-
-	
-	// restart for all but last node
-	if (restartStrip)
-	{
-		glPrimitiveRestartNV();
-	}
-}
-
-
-int Bvh::RenderBoundingBoxesImmediate(const BvhNodeContainer &nodes)
-{
-	timeSetup.Entry();
-	int renderedBoxes = 0;
-	
-	glBegin(GL_TRIANGLE_STRIP);
-
-	BvhNodeContainer::const_iterator bit, bit_end = nodes.end();
-
-	for (bit = nodes.begin(); bit != bit_end; ++ bit)
-	{
-		BvhNode *node = *bit;
-
-		renderedBoxes += node->mNumTestNodes;
-#if 0
-		const bool restartStrip = false;
-		RenderBoundingBoxImmediate(node->GetBox(), restartStrip);
-#else
-		//OUT1("nodes: " << node->mTestNodes.size() << " l: " << node->IsLeaf());
-		for (int i = 0; i < node->mNumTestNodes; ++ i)
-		{
-			RenderableHierarchyNode *testNode = mTestNodes[node->mTestNodesIdx + i];
-			const BoundingBox &box = testNode->GetBox();
-
-			// restart for all but last node
-			const bool restartStrip = (bit != bit_end - 1) || (i != node->mNumTestNodes - 1);
-
-			RenderBoundingBoxImmediate(box, restartStrip);
-		}
-#endif
-	}
-	glEnd();
-	timeSetup.Exit();
+}
+
+
+
+int Bvh::RenderBoundingBoxes(const BvhNodeContainer &nodes)
+{
+	int renderedBoxes = PrepareBoundingBoxesWithDrawArrays(nodes);
+	RenderBoundingBoxesWithDrawArrays(renderedBoxes);
 
 	return renderedBoxes;
-}
-
-
-int Bvh::RenderBoundingBoxes(const BvhNodeContainer &nodes)
-{
-	// always render in immediate mode if there is only one box to render
-	if (((nodes.size() == 1) && (nodes[0]->mNumTestNodes == 1)) || 
-		!Settings::Global()->get_nvocc_use_index_arrays())
-	{	
-		// render bounding boxes individually
-		return RenderBoundingBoxesImmediate(nodes);
-	}
-	else 
-	{
-		const int renderedBoxes = 
-			PrepareBoundingBoxesWithDrawArrays(nodes);
-		RenderBoundingBoxesWithDrawArrays(renderedBoxes);
-
-		return renderedBoxes;
-	}
 }
 
@@ -1726,6 +441,4 @@
 
 	///////////////
-
-	timeSetup.Entry();
 
 	int numNodes = 0;
@@ -1750,17 +463,12 @@
 	}
 
-	timeSetup.Exit();
-
 	return numNodes;
 }
 
 
-void Bvh::RenderBoundingBoxesWithDrawArrays(const int numNodes)
+void Bvh::RenderBoundingBoxesWithDrawArrays(int numNodes)
 {
 	//////
 	//-- Rendering the vbo
-
-	timeIssueDrawElements.Entry();
-
 	if (useVbos)
 		// set the vertex pointer to the vertex buffer
@@ -1774,6 +482,4 @@
 	// don't render first degenerate index
 	glDrawElements(GL_TRIANGLE_STRIP, numElements, GL_UNSIGNED_INT, mIndices + 1); 
-	
-	timeIssueDrawElements.Exit();
 }
 
@@ -1787,5 +493,5 @@
 	CollectNodes(mRoot, nodes);
 
-	OUT1("creating new indices");
+	cout << "creating new indices" << endl;
 
 	int numMaxIndices = 0;
@@ -1804,5 +510,5 @@
 
 
-	OUT1("creating global indices buffer");
+	cout << "creating global indices buffer" << endl;
 
 	if (mIndices) delete [] mIndices;
@@ -1831,5 +537,5 @@
 		for (int i = 0; i < node->mNumTestNodes; ++ i, numIndices += sNumIndicesPerBox)
 		{
-			RenderableHierarchyNode *testNode = mTestNodes[node->mTestNodesIdx + i];
+			BvhNode *testNode = mTestNodes[node->mTestNodesIdx + i];
 
 			// add indices to root node
@@ -1851,4 +557,5 @@
 
 
+/*
 void Bvh::ComputeIds()
 {
@@ -1856,5 +563,5 @@
 	// warning: root nodes local bvh are not in there, as they 
 	// are equivalent geometry bvh leaves
-	HierarchyNodeContainer nodes;
+	BvhNodeContainer nodes;
 	CollectAllNodes(mRoot, nodes);
 
@@ -1868,33 +575,28 @@
 	}
 }
-
+*/
 
 void Bvh::PrepareVertices()
 {
-	// collect all nodes, also the nodes from local bvh
-	// warning: root nodes local bvh are not in there, as they 
-	// are equivalent geometry bvh leaves
-	HierarchyNodeContainer nodes;
+	// collect all nodes
+	BvhNodeContainer nodes;
 
 	nodes.reserve(GetNumNodes());
-	CollectAllNodes(mRoot, nodes);
+	CollectNodes(mRoot, nodes);
 
 	const unsigned int bufferSize = 8 * (int)nodes.size();
-	mVertices = new Point3f[bufferSize];
+	mVertices = new Vector3[bufferSize];
 	
 	int i = 0;
 	
 	// store bounding box vertices
-	HierarchyNodeContainer::const_iterator lit, lit_end = nodes.end();
+	BvhNodeContainer::const_iterator lit, lit_end = nodes.end();
 
 	for (lit = nodes.begin(); lit != lit_end; ++ lit, i += 8)
 	{
-		RenderableHierarchyNode *node = *lit;
-		const Point3f *vertices = (const Point3f *)node->GetBox().getVertexData();
+		BvhNode *node = *lit;
 
 		for (int j = 0; j < 8; ++ j)
-		{	
-			((Point3f *)mVertices)[node->GetId() * 8 + j] = vertices[j];
-		}
+			((Vector3 *)mVertices)[node->GetId() * 8 + j] = node->GetBox().GetVertex(j);
 	}
 
@@ -1906,5 +608,5 @@
 	
 		glBufferDataARB(GL_ARRAY_BUFFER_ARB, 
-			            bufferSize * sizeof(Point3f), 
+			            bufferSize * sizeof(Vector3), 
 			            mVertices, 
 						GL_STATIC_DRAW_ARB);
@@ -1913,7 +615,7 @@
 
 		// data handled by graphics driver from now on
-		DELAPTR(mVertices);
-
-		OUT1("***** created vbos *********");
+		DEL_PTR(mVertices);
+
+		cout << "***** created vbos *********" << endl;
 	}
 	else
@@ -1922,10 +624,10 @@
         glVertexPointer(3, GL_FLOAT, 0, mVertices);
 
-		OUT1("created vertices");
-	}
-}
-
-
-void Bvh::SetMaxDepthForTestingChildren(const int maxDepth) 
+		cout << "******* created vertex arrays ********" << endl;
+	}
+}
+
+
+void Bvh::SetMaxDepthForTestingChildren(int maxDepth) 
 {
 	if (maxDepth != mMaxDepthForTestingChildren)
@@ -1937,39 +639,9 @@
 
 
-void Bvh::SetAreaRatioThresholdForTestingChildren(const float ratio) 
+void Bvh::SetAreaRatioThresholdForTestingChildren(float ratio) 
 {
 	if (ratio != mAreaRatioThreshold)
 	{
 		mAreaRatioThreshold = ratio;
-		RecomputeBounds();
-	}
-}
-
-
-void Bvh::SetVolRatioThresholdForTestingChildren(const float ratio) 
-{
-	if (ratio != mVolRatioThreshold)
-	{
-		mVolRatioThreshold = ratio;
-		RecomputeBounds();
-	}
-}
-
-
-void Bvh::SetUseTighterBoundsForTests(const bool tighterBoundsForTests)
-{
-	if (mUseTighterBoundsOnlyForLeafTests != tighterBoundsForTests)
-	{
-		mUseTighterBoundsOnlyForLeafTests = tighterBoundsForTests;
-		RecomputeBounds();
-	}
-}
-
-
-void Bvh::SetCollectTighterBoundsWithMaxLevel(bool t)
-{
-	if (mCollectTighterBoundsWithMaxLevel != t)
-	{
-		mCollectTighterBoundsWithMaxLevel = t;
 		RecomputeBounds();
 	}
@@ -1986,10 +658,5 @@
 	CollectNodes(mRoot, nodes);
 
-	OUT1("recomputing bounds, children will be tested in depth " << mMaxDepthForTestingChildren);
-
-	if (mCollectTighterBoundsWithMaxLevel)
-		OUT1("creating tighter bounds using max level");
-	else
-		OUT1("creating tighter bounds using best set");
+	cout << "recomputing bounds, children will be tested in depth " << mMaxDepthForTestingChildren << endl;
 
 	int success = 0;
@@ -2000,45 +667,15 @@
 		BvhNode *node = *lit;
 
-		if (mCollectTighterBoundsWithMaxLevel)
-		{
-			//OUT1("creating tighter bounds using max level");
-
-			// recreate list of nodes that will be tested as a proxy ...
-			if (CreateNodeRenderList(node))
-				++ success;
-		}
-		else
-		{
-			//OUT1("creating tighter bounds using best set");
-
-			HierarchyNodeContainer hnodes;
-			CollectBestNodes(node, hnodes);	
-
-			// the new test nodes are added at the end of the vector
-			node->mTestNodesIdx = mTestNodes.size();
-
-			HierarchyNodeContainer::const_iterator cit;
-
-			// use the found nodes as nodes during the occlusion tests
-			for (cit = hnodes.begin(); cit != hnodes.end(); ++ cit)
-			{
-				RenderableHierarchyNode *child = *cit;
-				mTestNodes.push_back(child);
-			}
-
-			node->mNumTestNodes = (int)hnodes.size();
-		}
-		//OUT1("testnodes: " << node->mNumTestNodes);
-	}
-
-	const float p = 100.0f * (float)success / nodes.size();
-
-	OUT1("created tighter bounds for " << p << " percent of the nodes");
+		// recreate list of nodes that will be tested as a proxy ...
+		if (CreateNodeRenderList(node))
+			++ success;
+	}
+
+	float p = 100.0f * (float)success / nodes.size();
+	cout << "created tighter bounds for " << p << " percent of the nodes" << endl;
 
 	// recreate indices used for indirect mode rendering
 	if (mIndices)
-	{
 		CreateIndices();
-	}
 }
 
@@ -2046,17 +683,10 @@
 bool Bvh::CreateNodeRenderList(BvhNode *node)
 {
-	HierarchyNodeContainer children;
-
-	if (mUseTighterBoundsOnlyForLeafTests && !node->IsLeaf())
-	{
-		children.push_back(node);
-	}
-	else
-	{
-		// collect nodes that will be tested instead of the leaf node
-		// in order to get a tighter bounding box test
-		CollectNodes(node, mMaxDepthForTestingChildren, children);
-	}
-
+	BvhNodeContainer children;
+
+	// collect nodes that will be tested instead of the leaf node
+	// in order to get a tighter bounding box test
+	CollectNodes(node, children, mMaxDepthForTestingChildren);
+	
 
 	// using the tighter bounds is not feasable in case
@@ -2068,24 +698,15 @@
 	float area = 0;
 
-	HierarchyNodeContainer::const_iterator cit;
+	BvhNodeContainer::const_iterator cit;
 
 	for (cit = children.begin(); cit != children.end(); ++ cit)
-	{
-		RenderableHierarchyNode *c = *cit;
-
-		area += c->GetBox().getSurface();
-		vol += c->GetBox().getVolume();
-	}
-
-	const float volRatio = vol / node->GetBox().getVolume();
-	const float areaRatio = area / node->GetBox().getSurface();
+		area += (*cit)->GetBox().SurfaceArea();
+
+	const float areaRatio = area / node->GetBox().SurfaceArea();
 	
 	bool success;
 
-	if ((areaRatio < mAreaRatioThreshold) &&
-		(volRatio < mVolRatioThreshold))
-	{
+	if (areaRatio < mAreaRatioThreshold)
 		success = true;
-	}
 	else
 	{
@@ -2098,10 +719,10 @@
 
 	// the new test nodes are added at the end of the vector
-	node->mTestNodesIdx = mTestNodes.size();
+	node->mTestNodesIdx = (int)mTestNodes.size();
 
 	// use the found nodes as nodes during the occlusion tests
 	for (cit = children.begin(); cit != children.end(); ++ cit)
 	{
-		RenderableHierarchyNode *child = *cit;
+		BvhNode *child = *cit;
 		mTestNodes.push_back(child);
 	}
@@ -2129,138 +750,4 @@
 
 
-int Bvh::PostProcessLeaves(BvhLeafContainer &leaves)
-{
-	OUT1("creating tighter bounds for leaves");
-
-	BvhLeafContainer::const_iterator lit, lit_end = leaves.end();
-
-	int i = 0;
-	int tighter = 0;
-
-	for (lit = leaves.begin(); lit != lit_end; ++ lit, ++ i)
-	{
-		BvhLeaf *leaf = *lit;
-
-		int triangleCount;
-		// collect the triangles from the stored geometry
-		Point3f *triangles = CollectTriangles(leaf, triangleCount);
-
-		if (CreateTighterBoundsForLeaf(leaf, triangles, triangleCount))
-			++ tighter;
-
-		leaf->mArea = ComputeGeometryArea(leaf, triangles, triangleCount);
-
-		delete [] triangles;
-
-		if (i % 1000 == 999)
-			OUT1(i << " leaves processed ");
-	}
-
-	const float p = 100.0f * tighter / leaves.size();
-	OUT1("created tighter bounds for " << p << " percent of the leaves");
-
-	return tighter;
-}
-
-
-bool Bvh::CreateTighterBoundsForLeaf(BvhLeaf *leaf, Point3f *triangles, const int triangleCount)
-{
-	// create a local bvh over the triangles
-	if (leaf->mTriangleBvh) delete leaf->mTriangleBvh;
-
-	leaf->mTriangleBvh = new TriangleBvh((Triangle *)triangles, triangleCount);
-
-	const int maxDepth = Settings::Global()->get_nvocc_local_bvh_max_depth();
-	const int maxTriangles = Settings::Global()->get_nvocc_local_bvh_max_triangles();
-	const int minArea = Settings::Global()->get_nvocc_local_bvh_min_area();
-	const int splitType = Settings::Global()->get_nvocc_local_bvh_split_type();
-
-	leaf->mTriangleBvh->SetMaxDepth(maxDepth);
-	leaf->mTriangleBvh->SetMaxTriangles(maxTriangles);
-	leaf->mTriangleBvh->SetMinAreaRatio(minArea);
-	leaf->mTriangleBvh->SetSplitType(splitType);
-	
-	leaf->mTriangleBvh->SetVerboseOutput(false);
-
-	// construct
-	leaf->mTriangleBvh->Construct();
-
-	return true;
-}
-
-
-float Bvh::ComputeGeometryArea(BvhLeaf *leaf, Point3f *triangles, const int triangleCount) const
-{
-	float area = 0;
-
-	for (int i = 0; i < triangleCount; ++ i)
-	{
-		area += ((Triangle *)triangles)[i].GetArea();
-	}
-
-	return area;
-}
-
-
-Point3f *Bvh::CollectTriangles(BvhLeaf *leaf, int &triangleCount)
-{
-	// count triangles in the leaf
-	triangleCount = 0;
-
-	for (int geomIdx = leaf->mFirst; geomIdx <= leaf->mLast; ++ geomIdx)
-	{
-		Shape3D *sh = static_cast<Shape3D *>(mGeometry[geomIdx]->GetNode());
-		IndexedTriangleStripArray *strips = static_cast<IndexedTriangleStripArray *>(sh->getGeometry());
-
-		triangleCount += strips->getNumTriangles();
-	}
-
-	Triangle *triangles = new Triangle[triangleCount];
-	//OUT1("The leaf contains " << triangleCount << " triangles in " << (int)geometry.size() << " nodes");
-
-	int currentIdx = 0;
-	
-	for (int geomIdx = leaf->mFirst; geomIdx <= leaf->mLast; ++ geomIdx)
-	{
-		NodeGeometry *geom = mGeometry[geomIdx];
-
-		Shape3D *sh = static_cast<Shape3D *>(geom->GetNode());
-		
-		IndexedTriangleStripArray *strips = 
-			static_cast<IndexedTriangleStripArray *>(sh->getGeometry());
-
-		// get indices of containted triangles (strips are converted before)
-		int *indices;
-	
-		int tCount = strips->getNumTriangles();
-		int indexCount = tCount * 3;
-		
-		// compute triangles from strips
-		Point3f *coordinates = (Point3f *)strips->getCoordRef3f();
-		strips->getTriangleCoordinateIndices(0, &indices, indexCount);
-
-		for (int i = 0; i < tCount; ++ i)
-		{
-			triangles[i + currentIdx].mVertices[0] = coordinates[indices[i * 3 + 0]]; 
-			triangles[i + currentIdx].mVertices[1] = coordinates[indices[i * 3 + 1]]; 
-			triangles[i + currentIdx].mVertices[2] = coordinates[indices[i * 3 + 2]]; 
-
-			if (geom->mMatId != NV_RenderPredictorRenderAction::NO_MAT)
-			{
-				const Matrix4f &m = mRenderer->app_mats[geom->mMatId];
-				Transform3D tf(m);
-				tf.transform(triangles[i + currentIdx].mVertices[0]);
-				tf.transform(triangles[i + currentIdx].mVertices[1]);
-				tf.transform(triangles[i + currentIdx].mVertices[2]);
-			}
-		}
-
-		currentIdx += tCount;
-	}
-
-	return (Point3f *)triangles;
-}
-
-
 int Bvh::CountTriangles(BvhLeaf *leaf) const
 {
@@ -2268,8 +755,6 @@
 	
 	for (int i = leaf->mFirst; i <= leaf->mLast; ++ i)
-	{
-		triangleCount += mGeometry[i]->mNumTriangles;
-	}
-
+		triangleCount += mGeometry[i]->GetGeometry()->CountTriangles();
+	
 	return triangleCount;
 }
@@ -2290,22 +775,11 @@
 			BvhLeaf *leaf = static_cast<BvhLeaf *>(node);
 
-			mBvhStats.mLeafSA += leaf->mBox.getSurface();
-			mBvhStats.mLeafVol += leaf->mBox.getVolume();
-
-			TriangleBvh::TriangleBvhStats tStats;
-			leaf->mTriangleBvh->GetBvhStats(tStats);
-
-			mBvhStats.mBoundsLeafSA += tStats.mLeafSA;
-			mBvhStats.mBoundsInteriorSA += tStats.mInteriorSA;
-
-			mBvhStats.mBoundsLeafVol += tStats.mLeafVol;
-			mBvhStats.mBoundsInteriorVol += tStats.mInteriorVol;
-
-			mBvhStats.mBoundsLeavesCount += leaf->mTriangleBvh->GetNumLeaves();
+			mBvhStats.mLeafSA += leaf->mBox.SurfaceArea();
+			mBvhStats.mLeafVol += leaf->mBox.GetVolume();
 		} 
 		else 
 		{
-			mBvhStats.mInteriorSA += node->mBox.getSurface();
-			mBvhStats.mInteriorVol += node->mBox.getVolume();
+			mBvhStats.mInteriorSA += node->mBox.SurfaceArea();
+			mBvhStats.mInteriorVol += node->mBox.GetVolume();
 
 			BvhInterior *interior = static_cast<BvhInterior *>(node);
@@ -2323,100 +797,18 @@
 void Bvh::PrintBvhStats() const
 {
-	//OUT1("triangle bvh surface " << mBvhStats.mBoundsLeafSA);
-	//OUT1("triangle bvh volume " << mBvhStats.mBoundsLeafVol);
-
-	OUT1("bvh stats:");
-	OUT1("interiorNodesSA = " << mBvhStats.mInteriorSA / mRoot->mBox.getSurface());
-	OUT1("leafNodesSA = " << mBvhStats.mLeafSA / mRoot->mBox.getSurface());
-	OUT1("interiorNodesVolume = " << mBvhStats.mInteriorVol / mRoot->mBox.getVolume());
-	OUT1("leafNodesVolume = " << mBvhStats.mLeafVol / mRoot->mBox.getVolume() << "\n");
-
-	OUT1("boundsInteriorNodesSA = " << mBvhStats.mBoundsInteriorSA / mBvhStats.mLeafSA);
-	OUT1("boundsLeafNodesSA = " << mBvhStats.mBoundsLeafSA / mBvhStats.mLeafSA);
-	OUT1("boundsInteriorNodesVolume = " << mBvhStats.mBoundsInteriorVol / mBvhStats.mLeafVol);
-	OUT1("boundsLeafNodesVolume = " << mBvhStats.mBoundsLeafVol / mBvhStats.mLeafVol << "\n");
-
-	OUT1("boundsLeaves: " <<  (float)mBvhStats.mBoundsLeavesCount / (float)GetNumLeaves() << "\n");
-	OUT1("geometry per leaf: " <<  mBvhStats.mGeometryRatio);
-	OUT1("triangles per leaf: " <<  mBvhStats.mTriangleRatio);
-	OUT1("");
-}
-
-
-static void RenderBoxForViz(const BoundingBox &box)
-{
-	glBegin(GL_LINE_LOOP);
-	glVertex3d(box.getLowerPtr()->x, box.getUpperPtr()->y, box.getLowerPtr()->z);
-	glVertex3d(box.getUpperPtr()->x, box.getUpperPtr()->y, box.getLowerPtr()->z);
-	glVertex3d(box.getUpperPtr()->x, box.getLowerPtr()->y, box.getLowerPtr()->z);
-	glVertex3d(box.getLowerPtr()->x, box.getLowerPtr()->y, box.getLowerPtr()->z);
-	glEnd();
-
-	glBegin(GL_LINE_LOOP);
-	glVertex3d(box.getLowerPtr()->x, box.getLowerPtr()->y, box.getUpperPtr()->z);
-	glVertex3d(box.getUpperPtr()->x, box.getLowerPtr()->y, box.getUpperPtr()->z);
-	glVertex3d(box.getUpperPtr()->x, box.getUpperPtr()->y, box.getUpperPtr()->z);
-	glVertex3d(box.getLowerPtr()->x, box.getUpperPtr()->y, box.getUpperPtr()->z);
-	glEnd();
-
-	glBegin(GL_LINE_LOOP);
-	glVertex3d(box.getUpperPtr()->x, box.getLowerPtr()->y, box.getLowerPtr()->z);
-	glVertex3d(box.getUpperPtr()->x, box.getLowerPtr()->y, box.getUpperPtr()->z);
-	glVertex3d(box.getUpperPtr()->x, box.getUpperPtr()->y, box.getUpperPtr()->z);
-	glVertex3d(box.getUpperPtr()->x, box.getUpperPtr()->y, box.getLowerPtr()->z);
-	glEnd();
-
-	glBegin(GL_LINE_LOOP);
-	glVertex3d(box.getLowerPtr()->x, box.getLowerPtr()->y, box.getLowerPtr()->z);
-	glVertex3d(box.getLowerPtr()->x, box.getLowerPtr()->y, box.getUpperPtr()->z);
-	glVertex3d(box.getLowerPtr()->x, box.getUpperPtr()->y, box.getUpperPtr()->z);
-	glVertex3d(box.getLowerPtr()->x, box.getUpperPtr()->y, box.getLowerPtr()->z);
-	glEnd();
-
-	glBegin(GL_LINE_LOOP);
-	glVertex3d(box.getLowerPtr()->x, box.getLowerPtr()->y, box.getLowerPtr()->z);
-	glVertex3d(box.getUpperPtr()->x, box.getLowerPtr()->y, box.getLowerPtr()->z);
-	glVertex3d(box.getUpperPtr()->x, box.getLowerPtr()->y, box.getUpperPtr()->z);
-	glVertex3d(box.getLowerPtr()->x, box.getLowerPtr()->y, box.getUpperPtr()->z);
-	glEnd();
-
-	glBegin(GL_LINE_LOOP);
-	glVertex3d(box.getLowerPtr()->x, box.getUpperPtr()->y, box.getLowerPtr()->z);
-	glVertex3d(box.getUpperPtr()->x, box.getUpperPtr()->y, box.getLowerPtr()->z);
-	glVertex3d(box.getUpperPtr()->x, box.getUpperPtr()->y, box.getUpperPtr()->z);
-	glVertex3d(box.getLowerPtr()->x, box.getUpperPtr()->y, box.getUpperPtr()->z);
-
-	glEnd();
-}
-
-
-void Bvh::RenderBoundingBoxesForViz(const int mode)
-{
-	BvhLeafContainer leaves;
-	leaves.reserve(mRoot->GetNumLeaves());
-
-	CollectLeaves(mRoot, leaves);
-
-	BvhLeafContainer::const_iterator it, it_end = leaves.end();
-
-	for (it = leaves.begin(); it != it_end; ++ it)
-	{
-		BvhLeaf *leaf = *it;
-
-		if ((mode == 0) || (mode == 2))
-		{
-			glColor3f(1.0f, 1.0f, 1.0f);
-            RenderBoxForViz(leaf->GetBox());
-		}
-		
-		if ((mode == 1) || (mode == 2)) 
-		{
-			glColor3f(1.0f, 0, 0);
-			for (int i = 0; i < leaf->mNumTestNodes; ++ i)
-			{
-				RenderBoxForViz(mTestNodes[leaf->mTestNodesIdx + i]->GetBox());
-			}
-		}
-	}
+	cout << "bvh stats:" << endl;
+	cout << "interiorNodesSA = " << mBvhStats.mInteriorSA / mRoot->mBox.SurfaceArea() << endl;
+	cout << "leafNodesSA = " << mBvhStats.mLeafSA / mRoot->mBox.SurfaceArea() << endl;
+	cout << "interiorNodesVolume = " << mBvhStats.mInteriorVol / mRoot->mBox.GetVolume() << endl;
+	cout << "leafNodesVolume = " << mBvhStats.mLeafVol / mRoot->mBox.GetVolume() << endl;
+
+	cout << "boundsInteriorNodesSA = " << mBvhStats.mBoundsInteriorSA / mBvhStats.mLeafSA << endl;
+	cout << "boundsLeafNodesSA = " << mBvhStats.mBoundsLeafSA / mBvhStats.mLeafSA << endl;
+	cout << "boundsInteriorNodesVolume = " << mBvhStats.mBoundsInteriorVol / mBvhStats.mLeafVol << endl;
+	cout << "boundsLeafNodesVolume = " << mBvhStats.mBoundsLeafVol / mBvhStats.mLeafVol << "\n" << endl;
+
+	cout << "boundsLeaves: " <<  (float)mBvhStats.mBoundsLeavesCount / (float)GetNumLeaves() << "\n" << endl;
+	cout << "geometry per leaf: " <<  mBvhStats.mGeometryRatio << endl;
+	cout << "triangles per leaf: " <<  mBvhStats.mTriangleRatio << endl;
 }
 
@@ -2428,5 +820,5 @@
 	for (int i = node->mFirst; i <= node->mLast; ++ i)
 	{
-		numTriangles += mGeometry[i]->mNumTriangles;
+		numTriangles += mGeometry[i]->GetGeometry()->CountTriangles();
 	}
 
